/* @consulta2.sql */

-- SET AUTOTRACE ON
SET TRIMSPOOL ON
SET TRIMOUT   ON
SET WRAP OFF
column balanceT    format 990.99
column importe     format 990.99
column saldoT      format 990.99
/*                                                                                      (C2.1)
  ##########################################################################################*/
SELECT idTarjeta, balanceT
FROM tarjeta, (SELECT idcontrato idMax, max(balanceT) maxDif FROM tarjeta GROUP BY idcontrato)
WHERE idcontrato = idMax AND balanceT = maxDif
ORDER BY idTarjeta;

/*                                                                                      (C2.2)
  ############################################################################################
  tarjetas de cada contrato en las que la diferencia entre el dinero recargado con la tarjeta
  y el gastado con la tarjeta es mayor
  ##########################################################################################*/
SELECT T.idTarjeta, balanceT
FROM tarjeta T
WHERE balanceT = (SELECT max(balanceT) FROM tarjeta WHERE idcontrato = T.idcontrato)
ORDER BY T.idTarjeta;

/*                                                                                      (C2.3)
  ##########################################################################################*/
SELECT idTarjeta, balanceT
FROM (SELECT idTarjeta, balanceT, max(balanceT) OVER (PARTITION BY idcontrato) maxDif
      FROM tarjeta)
WHERE balanceT = maxDif
ORDER BY idTarjeta;

/*                                                                                      (C2.4)
  ##########################################################################################*/
-- si no se usa el disparador para mantener el atributo balanceT resulta un poco ms largo
CREATE VIEW tarjPrep AS (
 SELECT idTarjeta, T.idcontrato
 FROM tarjeta T, contrato C
 WHERE T.idcontrato = C.idcontrato AND tipoContrato = 'P'
);

CREATE VIEW saldoTarj AS (
 SELECT idTarjeta, sum(importe) saldoT FROM ACCESOS GROUP BY idTarjeta
 UNION
 SELECT idTarjeta, 0 FROM tarjPrep WHERE idTarjeta NOT IN (SELECT idTarjeta FROM ACCESOS)
);

CREATE VIEW maxDifcon AS (
 SELECT idcontrato, max(saldoT) maxDif
 FROM tarjPrep T, saldoTarj S
 WHERE T.idTarjeta = S.idTarjeta
 GROUP BY idcontrato
);

SELECT T.idTarjeta, saldoT
FROM  tarjPrep T, saldoTarj S, maxDifcon MX
WHERE T.idTarjeta = S.idTarjeta AND T.idcontrato = MX.idcontrato AND saldoT = maxDif;

SELECT * FROM maxDifcon;
SELECT * FROM tarjPrep;
SELECT * FROM saldoTarj;

DROP VIEW tarjPrep;
DROP VIEW maxDifcon;
DROP VIEW saldoTarj;

/*                                                                                      (C2.5)
  ##########################################################################################*/
-- obsrvese que en esta implementacin no se muestran las tarjetas que sin actividad
CREATE VIEW tarjPrep AS (
 SELECT T.idTarjeta, T.idcontrato, (SELECT sum(importe) FROM ACCESOS
                                    WHERE idTarjeta = T.idTarjeta) saldoT
 FROM tarjeta T, contrato C
 WHERE T.idcontrato = C.idcontrato AND tipoContrato = 'P'
);

CREATE VIEW maxDifcon AS (
 SELECT idcontrato, max(saldoT) maxDif FROM tarjPrep GROUP BY idcontrato
);

SELECT idTarjeta, saldoT
FROM  tarjPrep T, maxDifcon MX
WHERE T.idcontrato = MX.idcontrato AND saldoT = maxDif;

SELECT * FROM tarjPrep;
SELECT * FROM maxDifcon;
DROP VIEW maxDifcon;
DROP VIEW tarjPrep;

